gtk-sharp 2.12.0.0 Gtk# is thread aware, but not thread safe; See the Gtk# Thread Programming for details. Gtk.Container Container for widgets from other processes.

Together with , provides the ability to embed widgets from one process into another process in a fashion that is transparent to the user. One process creates a widget and, passes the window ID of that widget to the other process, which then creates a with that window ID. Any widgets contained in the then will appear inside the first applications window.

The window ID of the is obtained by using . Before using this function, the socket must have been realized, and therefore, have been added to its parent.

`Gtk.Socket socket = new Gtk.Socket; socket.Show (); parent.Add (socket); Console.WriteLine ("The ID of the sockets window is {0}", socket.Id);`

Note that if you pass the window ID of the socket to another process that will create a plug in the socket, you must make sure that the socket widget is not destroyed until that plug is created. Violating this rule will cause unpredictable consequences, the most likely consequence being that the plug will appear as a separate toplevel window. You can check if the plug has been created by examining the plug_window field of the structure. If this field is non-, then the plug has been successfully created inside of the socket.

When Gtk# is notified that the embedded window has been destroyed, then it will destroy the socket as well. You should always, therefore, be prepared for your sockets to be destroyed at any time when the main event loop is running.

The communication between a and a follows the XEmbed protocol. This protocol has also been implemented in other toolkits, e.g. Qt, allowing the same level of integration when embedding a Qt widget in GTK or vice versa.

A socket can also be used to swallow arbitrary pre-existing top-level windows using , though the integration when this is done will not be as close as between a and a .

- Constructor
  2.12.0.0
  Default constructor
- Constructor
  2.12.0.0
  System.Obsolete
  a
  Protected Constructor.
  Chain to this constructor if you have manually registered a native value for your subclass.
- Constructor
  2.12.0.0
  Pointer to the C object.
  Internal constructor

  This is an internal constructor, and should not be used by user code.

- Method
  2.12.0.0
  System.Void `` an object of type Adds an XEMBED client, such as a , to the .

  The client may be in the same process or in a different process.

  To embed a in a , you can either create the with , call to get the window ID of the plug, and then pass that to the , or you can call to get the window ID for the socket, and call passing in that ID.

  The must have already be added into a toplevel window before you can make this call.

- Property
  2.12.0.0
  GLib.GType GType Property. a Returns the native value for .
- Property
  2.12.0.0
  System.UInt32 The window ID of a widget. an object of type This can be used to create a client embedded inside the socket, for instance with . The must have already be added into a toplevel window before you can make this call.
- Method
  2.12.0.0
  GLib.DefaultSignalHandler(ConnectionMethod="OverridePlugAdded", Type=typeof(Gtk.Socket))
  System.Void Default handler for the event. Override this method in a subclass to provide a default handler for the event.
- Method
  2.12.0.0
  GLib.DefaultSignalHandler(ConnectionMethod="OverridePlugRemoved", Type=typeof(Gtk.Socket))
  System.Boolean Default handler for the event. a Override this method in a subclass to provide a default handler for the event.
- Event
  2.12.0.0
  GLib.Signal("plug_added")
  System.EventHandler This event is emitted when a client is successfully added to the socket.
- Event
  2.12.0.0
  GLib.Signal("plug_removed")
  Gtk.PlugRemovedHandler This event is emitted when a client is removed from the socket. The default action is to destroy the widget, so if you want to reuse it you must add a signal handler that returns .
- Method
  2.12.0.0
  System.Obsolete
  System.Void `` a , the window ID of an existing toplevel window. Reparents a pre-existing toplevel window into a . This is meant to embed clients that do not know about embedding into a , however doing so is inherently unreliable, and using this function is not recommended. The must have already been added into a toplevel window before you can make this call.